# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = ['WafPackage']


class WafPackage(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action_mode: Optional[pulumi.Input[str]] = None,
                 package_id: Optional[pulumi.Input[str]] = None,
                 sensitivity: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Provides a Cloudflare WAF rule package resource for a particular zone. This can be used to configure firewall behaviour for pre-defined firewall packages.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_cloudflare as cloudflare

        owasp = cloudflare.WafPackage("owasp",
            action_mode="simulate",
            package_id="a25a9a7e9c00afc1fb2e0245519d725b",
            sensitivity="medium",
            zone_id="ae36f999674d196762efcc5abb06b345")
        ```

        ## Import

        Packages can be imported using a composite ID formed of zone ID and the WAF Package ID, e.g.

        ```sh
         $ pulumi import cloudflare:index/wafPackage:WafPackage owasp ae36f999674d196762efcc5abb06b345/a25a9a7e9c00afc1fb2e0245519d725b
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action_mode: The action mode of the package, can be one of ["block", "challenge", "simulate"].
        :param pulumi.Input[str] package_id: The WAF Package ID.
        :param pulumi.Input[str] sensitivity: The sensitivity of the package, can be one of ["high", "medium", "low", "off"].
        :param pulumi.Input[str] zone_id: The DNS zone ID to apply to.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['action_mode'] = action_mode
            if package_id is None:
                raise TypeError("Missing required property 'package_id'")
            __props__['package_id'] = package_id
            __props__['sensitivity'] = sensitivity
            if zone_id is None:
                raise TypeError("Missing required property 'zone_id'")
            __props__['zone_id'] = zone_id
        super(WafPackage, __self__).__init__(
            'cloudflare:index/wafPackage:WafPackage',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action_mode: Optional[pulumi.Input[str]] = None,
            package_id: Optional[pulumi.Input[str]] = None,
            sensitivity: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'WafPackage':
        """
        Get an existing WafPackage resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action_mode: The action mode of the package, can be one of ["block", "challenge", "simulate"].
        :param pulumi.Input[str] package_id: The WAF Package ID.
        :param pulumi.Input[str] sensitivity: The sensitivity of the package, can be one of ["high", "medium", "low", "off"].
        :param pulumi.Input[str] zone_id: The DNS zone ID to apply to.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["action_mode"] = action_mode
        __props__["package_id"] = package_id
        __props__["sensitivity"] = sensitivity
        __props__["zone_id"] = zone_id
        return WafPackage(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="actionMode")
    def action_mode(self) -> pulumi.Output[Optional[str]]:
        """
        The action mode of the package, can be one of ["block", "challenge", "simulate"].
        """
        return pulumi.get(self, "action_mode")

    @property
    @pulumi.getter(name="packageId")
    def package_id(self) -> pulumi.Output[str]:
        """
        The WAF Package ID.
        """
        return pulumi.get(self, "package_id")

    @property
    @pulumi.getter
    def sensitivity(self) -> pulumi.Output[Optional[str]]:
        """
        The sensitivity of the package, can be one of ["high", "medium", "low", "off"].
        """
        return pulumi.get(self, "sensitivity")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        The DNS zone ID to apply to.
        """
        return pulumi.get(self, "zone_id")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

